library IEEE;
use IEEE.Std_logic_1164.all;

entity Practica4 is
  port (Ready,Entrada_codi,Tecla,P_oberta,P_tancada: out Std_logic;
  		Clock,Reset: in Std_logic;
    	Entrada: in Std_logic_vector(9 downto 0));
end;

architecture RTL of Practica4 is
type StateType is (S0, S1, S2, S3, S4, S5, S6, S7, S8, S9, S10, S11, S12, S13, S14, S15, S16);
signal State,NextState: StateType;
begin
	Registers:process (Clock, Reset) is
	  begin
		if Reset = '1' then
			State <= S0;
		elsif rising_edge(Clock) then
			State <= NextState;
	  end if;
	end process Registers;
	
	C_logic:process (State,Entrada) is
	begin
		Entrada_codi<='0';
		Tecla<='0';
		P_oberta<='0';
		P_tancada<='0';
		Tecla<='0';
		Ready<='0';
		case State is
			when S0 =>
				Ready<='1';
				if Entrada = "0000000100" then
					NextState <= S1;
				elsif Entrada = "0000000000" then
					NextState <= S0;
				else
					NextState <= S2;
				end if;
			when S1 =>
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S3;
				else
					NextState <= S1;
				end if;
			when S2 =>
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S14;
				else
					NextState <= S2;
				end if;
			when S3 =>
				Entrada_codi<='1';
				if Entrada = "0000001000" then
					NextState <= S5;
				elsif Entrada = "0000000000" then
					NextState <= S3;
				else
					NextState <= S4;
				end if;
			when S4 =>
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S15;
				else
					NextState <= S4;
				end if;
			when S5 => 
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S6;
				else
					NextState <= S5;
				end if;
			when S6 => 
				Entrada_codi<='1';
				if Entrada = "0000100000" then
					NextState <= S8;
				elsif Entrada = "0000000000" then
					NextState <= S6;
				else
					NextState <= S7;
				end if;
			when S7 => 
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S16;
				else
					NextState <= S7;
				end if;		
			when S8 => 
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S9;
				else
					NextState <= S8;
				end if;			
			when S9 => 
				Entrada_codi<='1';
				if Entrada = "0000000010" then
					NextState <= S11;
				elsif Entrada = "0000000000" then
					NextState <= S9;
				else
					NextState <= S10;
				end if;	
			when S10 => 
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S13;
				else
					NextState <= S10;
				end if;	
			when S11 =>
				Entrada_codi<='1';
				Tecla<='1';
				if Entrada = "0000000000" then
					NextState <= S12;
				else
					NextState <= S11;
				end if;	
			when S12 => 
				P_oberta<='1';
			when S13 => 
				P_tancada<='1';
			when S14 => 
				Entrada_codi<='1';
				if Entrada = "0000000000" then
					NextState <= S14;
				else
					NextState <= S4;
				end if;	
			when S15 =>
				Entrada_codi<='1';
				if Entrada = "0000000000" then
					NextState <= S15;
				else
					NextState <= S7;
				end if;	
			when S16 =>
				Entrada_codi<='1';
				if Entrada = "0000000000" then
					NextState <= S16;
				else
					NextState <= S10;
				end if;	
		end case;
	end process C_logic;
end;




